<template>
  <v-container fluid>
    <div class="mt-140">
      <v-row class="pa-12">
        <v-col cols="12" md="8">
          <div class="blogSelected">
            <div class="primary-infoes">
              <v-img
                v-if="hasimage"
                :src="require(`~/assets/images/blog/${hero}`).src"
                :srcset="require(`~/assets/images/blog/${hero}`).srcSet"
                :alt="title"
                gradient="to bottom, rgba(0,0,0,0.0) 40%, rgba(0,0,0,0.7)"
                class="lazyload white--text align-end"
                cover
                height="500"
              >
                <v-card-title v-scrollAnime>
                  <h1 class="blog-title pa-5">
                    {{ title }}
                  </h1>
                </v-card-title>
              </v-img>
              <div class="d-flex pa-2 pr-6 pl-6 grey darken-4 white--text">
                <div>
                  <span>
                    {{ year }}
                  </span>
                </div>
                <span class="pr-2 pl-2"> /</span>
                <div>
                  <span>
                    {{ category }}
                  </span>
                </div>
                <v-spacer></v-spacer>
                <nuxt-link :to="localePath('blog')" class="white--text">
                  {{ $t('comeBack') }}
                  <v-icon class="white--text">mdi-arrow-left</v-icon>
                </nuxt-link>
              </div>
              <div v-scrollAnime class="mt-10 mb-6">
                <v-alert class="pa-8" color="#ffd0a6" border="left">
                  <blockquote class="blockquote">
                    <v-icon>mdi-white-balance-incandescent </v-icon>
                    {{ description }}
                  </blockquote>
                </v-alert>
              </div>
            </div>

            <div v-scrollAnime class="text-typo">
              <client-only>
                <DynamicMarkdown
                  :render-func="renderFunc"
                  :static-render-funcs="staticRenderFuncs"
                />
              </client-only>
            </div>
          </div>
        </v-col>
        <v-col cols="12" md="4"> ستون دوم </v-col>
      </v-row>
    </div>
  </v-container>
</template>

<script>
import DynamicMarkdown from '~/components/Markdown/DynamicMarkdown.vue';

export default {
  components: { DynamicMarkdown },
  async asyncData({ params, app }) {
    // console.log(params.slug);
    const fileContent = await import(
      `~/contents/${app.i18n.locale}/blog/${params.slug}.md`
    );
    // console.log(fileContent);
    const attr = fileContent.attributes;
    return {
      name: params.slug,
      title: attr.title,
      trans: attr.trans,
      year: attr.year,
      hero: attr.hero,
      id: attr.id,
      cardAlt: attr.cardAlt,
      hasimage: attr.hasImage,
      category: attr.category,
      description: attr.description,
      renderFunc: `(${fileContent.vue.render})`,
      staticRenderFuncs: `[${fileContent.vue.staticRenderFns}]`,
      // image: {
      //   main: attr.image && attr.image.main,
      //   og: attr.image && attr.image.og
      // }
    };
  },

  nuxtI18n: {
    seo: false,
  },

  computed: {
    // ogImage() {
    //   return `${process.env.baseUrl}/images/blog/${this.id}/_thumbnail.jpg`;
    // },
    pageTitle() {
      return this.title;
    },
    showLocales() {
      return this.$i18n.locales.filter(
        (locale) => locale.code !== this.$i18n.locale,
      );
    },
    hreflang() {
      if (!this.trans) {
        return '';
      }
      return {
        hid: 'alternate-hreflang-' + this.showLocales[0].iso,
        rel: 'alternate',
        // eslint-disable-next-line prettier/prettier
        href: `${
          process.env.baseUrl + (this.showLocales[0].code === 'fa' ? '' : '/en')
        }/blog/${this.trans}`,
        hreflang: this.showLocales[0].code,
      };
    },
  },

  // head() {
  //   return {
  //     title: this.title,
  //     htmlAttrs: {
  //       lang: this.$i18n.locale,
  //     },
  //     meta: [
  //       {
  //         name: 'description',
  //         property: 'og:description',
  //         content: this.description,
  //         hid: 'description',
  //       },
  //       { property: 'og:title', content: this.pageTitle },
  //       { property: 'og:image', content: this.ogImage },
  //       { name: 'twitter:description', content: this.description },
  //       { name: 'twitter:image', content: this.ogImage },
  //     ],
  //     link: [this.hreflang],
  //   };
  // },
};
</script>

<style lang="scss" scoped>
.blog-title {
  font-size: 1.7em;
}
.before-enter {
  opacity: 0.2;
  transform: translateY(200px);
  transition: all 2s ease-out;
}
.enter {
  opacity: 1;
  transform: translateY(0px);
}
</style>
